#ifndef DESSIN_H
#define DESSIN_H

#define RED 0
#define GREEN 1
#define BLUE 2

float *Lrnd;

struct Couleur
{
	float Rouge;
	float Vert;
	float Bleu;
};

float* RandInit(int nb)
{
	srand(time(NULL));
	float *retour;
	retour = (float*)malloc(sizeof(int)*nb);
	for(int c=0; c<nb; c++)
		retour[c] = (FL rand()/ (FL RAND_MAX));
	return retour;
}

float* GaussRandInit(int nb)
{
	srand(time(NULL));
	float *retour;
	unsigned long tmp;
	retour = (float*)malloc(sizeof(int)*nb);
	for(int c=0; c<nb; c++)
	{
		tmp = 0;
		for(int d=0; d < 3; d++)
			tmp += rand();
		tmp = tmp/3;
		retour[c] = (FL tmp)/ FL RAND_MAX;
		retour[c] = 1.0 - retour[c];
		if(retour[c] > 1.0 || retour[c] < 0.0)
		{
			printf("Out of range: %f -- c=%d -- tmp=%ld\n", retour[c],c, tmp);
			exit(0);
		}
	}
	return retour;
}

float GetRand(float* Tab, int x, int y, int offset)
{
	while(x < 0) x+=256;
	while(y < 0) y+=256;
	offset*=offset*7;
	return Tab[(x*256+y+offset)%65536];
}

float* PictureInit(int width, int height, int size)
{
	float* Limage = (float*) malloc(sizeof(float)*width*height*size);
	for(int i=0; i < height; i++)
		for(int j=0; j < width; j++)
			Limage[(i*width+j)*3] = Limage[(i*width+j)*3+1] = Limage[(i*width+j)*3+2] = 0.0;
	printf("Initialisation d'une image de %dx%d pixels (%dKo)\n", width, height, sizeof(float)*width*height*3/1024);
	return Limage;
}

inline float GetPix(float* image,int x,int y,int channel)
{
	return image[(y*width+x)*3+channel];
}

inline void SetPix(float* image,int x,int y,int channel, float value)
{
	image[(y*width+x)*3+channel] = value;
}

float* BitmapInit(int width, int height)
{
	float* Bitmap = (float*) malloc(sizeof(float)*width*height);
	for(int i=0; i < height; i++)
		for(int j=0; j < width; j++)
			Bitmap[(i*width+j)] = 0.0;
	printf("Initialisation d'une bitmap de %dx%d pixels (%dKo)\n", width, height, sizeof(float)*width*height/1024);
	return Bitmap;
}

inline float GetBit(float* bitmap,int x,int y)
{
	return bitmap[(y*width+x)];
}

inline void SetBit(float* bitmap,int x,int y, float value)
{
	bitmap[(y*width+x)] = value;
}

void ColorMap(float* Image, float* Bitmap, int width, int height, Couleur back, Couleur fore)
{
	int now = glutGet(GLUT_ELAPSED_TIME);
	float tmp;
	Couleur colo;
	for(int i=0; i < height; i++)
		for(int j=0; j < width; j++)
		{
			tmp = GetBit(Bitmap, j, i);
			SetPix(Image, j, i, RED, 1.0 - tmp*(fore.Rouge - back.Rouge));
			SetPix(Image, j, i, GREEN, 1.0 - tmp*(fore.Vert - back.Vert));
			SetPix(Image, j, i, BLUE, 1.0 - tmp*(fore.Bleu - back.Bleu));
		}
		now = glutGet(GLUT_ELAPSED_TIME) - now;
		printf("ColorMap: %dms\n", now);
}

//////////////////////////////////////////////////////////////////////////
// 	BEWARE ! ! ! NOT TO BE FORGOTTEN ! ! !
// 			SetPix(Bitmap, j, i, BLUE, 1.0-(buf*0.48));
// 			SetPix(Bitmap, j, i, GREEN, 1.0-(buf*0.74));
// 			SetPix(Bitmap, j, i, RED, 1.0-(buf*0.9));
//////////////////////////////////////////////////////////////////////////

float GetPt(int pt)
{
	return FL pt/ FL nbpts -0.5;
}

float ValPt(int pt)
{
	while(pt >= nbpts)
		pt -= nbpts;
	while(pt < 0)
		pt += nbpts;
	return (points[pt]);
}

float LinearInterpolate(float pt1, float v1, float pt2, float v2, float x)
{
	float tmp = (v2 - v1) / (pt2 - pt1);
// 	printf("tmp: %f, x*tmp=%f\n", tmp, x*tmp);
	return ((x-pt1) * tmp) + v1;
}

float LinearInterpolate(float p0, float p1, float x)
{
	return p0 + (p1 - p0)*x;
}

inline float CubicInterpolate(float p0,float p1, float p2, float p3, float x)
{
	float P = (p3 - p2) - (p0 - p1);
	float Q = (p0 - p1) - P;
	float R = p2 - p0;
	float S = p1;
	return P*x*x*x + Q*x*x + R*x + S;
}


float CI3D(float p0,float p1, float p2, float p3, float x)
{

	float P = (p3 - p2) - (p0 - p1);
	float Q = (p0 - p1) - P;
	float R = p2 - p0;
	float S = p1;
	return P*x*x*x + Q*x*x + R*x + S;
}


void deca(pt a, pt b, pt c, pt d)
{
	glVertex3f(a.x, a.y, a.z);
	glVertex3f(b.x, b.y, b.z);
	glVertex3f(c.x, c.y, c.z);
	glVertex3f(d.x, d.y, d.z);
}

void Fill(float* Bitmap, int width, int height, int cells, float ampli, float *rands)
{
	int spanw = width/cells;
	int spanh = height/cells;
	for(int i=0; i<height; i++)
	{
		int Oy = i/(spanh);
		float y = FL (i%spanh)/spanh;
		for(int j=0; j<width; j++)
		{
			int Ox = j/(spanw);
			float x = FL (j%spanw)/spanw;
// 			float A = LinearInterpolate(GetRand(rands,Ox%256,Oy%256),GetRand(rands,Ox%256,(Oy+1)%256),y);
// 			float B = LinearInterpolate(GetRand(rands,(Ox+1)%256,Oy%256),GetRand(rands,(Ox+1)%256,(Oy+1)%256),y);
// 			float val = LinearInterpolate(A,B,x);
			
			float A = CubicInterpolate(GetRand(rands,(Ox-1)%256,(Oy-1)%256,cells),
					GetRand(rands,(Ox-1)%256,Oy%256,cells),
					GetRand(rands,(Ox-1)%256,(Oy+1)%256,cells),
					GetRand(rands,(Ox-1)%256,(Oy+2)%256,cells),
						y);
			float B = CubicInterpolate(GetRand(rands,(Ox)%256,(Oy-1)%256,cells),
					GetRand(rands,(Ox)%256,Oy%256,cells),
					GetRand(rands,(Ox)%256,(Oy+1)%256,cells),
					GetRand(rands,(Ox)%256,(Oy+2)%256,cells),
					y);
			float C = CubicInterpolate(GetRand(rands,(Ox+1)%256,(Oy-1)%256,cells),
					GetRand(rands,(Ox+1)%256,Oy%256,cells),
					GetRand(rands,(Ox+1)%256,(Oy+1)%256,cells),
					GetRand(rands,(Ox+1)%256,(Oy+2)%256,cells),
					y);
			float D = CubicInterpolate(GetRand(rands,(Ox+2)%256,(Oy-1)%256,cells),
					GetRand(rands,(Ox+2)%256,Oy%256,cells),
					GetRand(rands,(Ox+2)%256,(Oy+1)%256,cells),
					GetRand(rands,(Ox+2)%256,(Oy+2)%256,cells),
					y);
			float val = CubicInterpolate(A,B,C,D,x);
			
			val -= 0.5;
			val *= 2.0*ampli;
// 			if(!(j%50)) printf("test: x=%d, y=%d, val--> %f\n", j, i, val);
			val += GetBit(Bitmap,j,i);
			if(val > 1.0) val = 1.0;
			if(val < -1.0) val = -1.0;
			SetBit(Bitmap,j,i,val);
// 			if(!(j%50)) printf("value: x=%d, y=%d, --> %f --- Ox=%d, Oy=%d\n", j,i,val, Ox,Oy);
// 		int offset = cells*2;
// 		int a = (i*width+j)*3;
		
		/*Bitmap[a] += ampli*
		LinearInterpolate(randx[(offset+j/(spanw))%512], randx[(offset+j/(spanw)+1)%512],FL(j%(width/cells))/(FL width/FL cells))
		*LinearInterpolate(randx[(offset+i/(height/cells))%512], randx[(offset+i/(height/cells)+1)%512],FL(i%(height/cells))/(FL height/FL cells));*/
// 		float A = LinearInterpolate(rands[i/spanh],rands[i/spanh+1], FL (i%spanh)/FL spanh);
// 		float B = LinearInterpolate(rands[i/spanh],rands[i/spanh+1], FL (i%spanh)/FL spanh);
// 		Bitmap[a] += ampli;
// 		if(Bitmap[a] > 1.0)
// 			Bitmap[a] = 1.0;
// 		if(Bitmap[a] < 0.0)
// 			Bitmap[a] = 0.0;
// 		Bitmap[a+1] = Bitmap[a+2] = Bitmap[a];
		}
	}
}

// Make solid noise in a bitmap
void SolidNoise(float* Bitmap, int width, int height, float *rands)
{
	long start = time(NULL);
	for(int i=0; i<height; i++)
		for(int j=0; j<width; j++)
		{
			// Make sure the bitmap is empty before starting filling it in
			SetBit(Bitmap, j, i, 0.0);
			SetBit(Bitmap, j, i, 0.0);
			SetBit(Bitmap, j, i, 0.0);
		}
	int s=5, f=9;
	for(int c=s; c < f; c++)
	{
		//Note: Fill(Bitmap, width, height, cells, ampli)
		Fill(Bitmap, width, height, c, 1.0/FL c, rands);
		printf("%d%% effectues...\n", 100*(c-s+1)/(f-s));
		progbar += 0.1/FL(f-s);
	}
	
	// Normalization
	for(int i=0; i<height; i++)
		for(int j=0; j<width; j++)
		{
			float buf = GetBit(Bitmap, j, i);
			buf += 1.0;
			buf = buf/2.0;
//			buf = fabs(cosf(buf*PI));
			SetBit(Bitmap, j, i, buf);
// 			buf = 1.0 - buf;

		}
	long temps = time(NULL) - start;
	printf("Temps de calcul: %ds\n", temps);
}





void joli1(float* Image, int width, int height)
{
	for(int i=0; i<height; i++)
		for(int j=0; j<width; j++)
		{
			Image[(i*width+j)*3] = (FL i+FL j)/(FL width+FL height);
			Image[(i*width+j)*3+1] = FL Lrnd[(i*i*j*j)%512];//(FL i+FL j)/(FL width+FL height);
			Image[(i*width+j)*3+2] = 1.0 - (FL i+FL j)/(FL width+FL height);
// 			printf("nombre: %f\n", (FL i+FL j)/(FL width+ FL height));
		}
}


void Draw_Tableau()
{
	glColor3f(1.0,1.0,0.0);
	glBegin(GL_LINE_LOOP);
	glVertex3f(-10.0, 0.0, -10.0);
	glVertex3f(10.0, 0.0, -10.0);
	glVertex3f(10.0, 0.0, 10.0);
	glVertex3f(-10.0, 0.0, 10.0);
	glEnd();
	glColor3f(0.0,1.0,0.0);
	glBegin(GL_LINE_LOOP);
	glVertex3f(-0.5, 0.5, 0.0);
	glVertex3f(0.5, 0.5, 0.0);
	glVertex3f(0.5, -0.5, 0.0);
	glVertex3f(-0.5, -0.5, 0.0);
	glEnd();
	glBegin(GL_LINE_STRIP);
	glVertex3f(-0.5,0.0,0.0);
	glVertex3f(0.5,0.0,0.0);
	glEnd();
	glColor3f(0.0,0.0,1.0);
	glBegin(GL_LINE_STRIP);
	glVertex3f(-0.5,0.2,0.0);
	glVertex3f(0.5,0.2,0.0);
	glEnd();
	glBegin(GL_LINE_STRIP);
	glVertex3f(-0.5,-0.2,0.0);
	glVertex3f(0.5,-0.2,0.0);
	glEnd();
	glBegin(GL_LINE_STRIP);
	glVertex3f(-0.5,0.4,0.0);
	glVertex3f(0.5,0.4,0.0);
	glEnd();
	glBegin(GL_LINE_STRIP);
	glVertex3f(-0.5,-0.4,0.0);
	glVertex3f(0.5,-0.4,0.0);
	glEnd();
	glBegin(GL_LINE_STRIP);
	glVertex3f(-0.2,-0.5,0.0);
	glVertex3f(-0.2,0.5,0.0);
	glEnd();
	glBegin(GL_LINE_STRIP);
	glVertex3f(0.2,-0.5,0.0);
	glVertex3f(0.2,0.5,0.0);
	glEnd();
	glBegin(GL_LINE_STRIP);
	glVertex3f(-0.4,-0.5,0.0);
	glVertex3f(-0.4,0.5,0.0);
	glEnd();
	glBegin(GL_LINE_STRIP);
	glVertex3f(0.4,-0.5,0.0);
	glVertex3f(0.4,0.5,0.0);
	glEnd();
	glBegin(GL_LINE_STRIP);
	glVertex3f(0.,-0.5,0.0);
	glVertex3f(0.,0.5,0.0);
	glEnd();
	glColor3f(1.0,0.0,0.0);
	glBegin(GL_LINE_STRIP);
	for(int i=0; i < nbpts; i++)
	{
		for(int c=0; c < resol; c++)
		{
			glVertex3f(GetPt(i)+ FL c/ FL (resol*nbpts), LinearInterpolate(GetPt(i), ValPt(i), GetPt(i+1), ValPt(i+1), GetPt(i) + FL c/ FL (resol*nbpts)), 0.0);
// 				printf("x: %f, y: %f -- i=%d, c=%d\n", GetPt(i)+ FL c/ FL (resol*nbpts), LinearInterpolate(GetPt(i), ValPt(i), GetPt(i+1), ValPt(i+1), GetPt(i) + FL c/ FL (resol*nbpts)), i, c);
// 				printf("LinearInterpolate(pt1:%f, v1:%f, pt2:%f, v2:%f, x=%f) = %f\n", GetPt(i),ValPt(i),GetPt(i+1),ValPt(i+1),GetPt(i) + FL c/ FL (resol*nbpts), LinearInterpolate(GetPt(i), ValPt(i), GetPt(i+1), ValPt(i+1), GetPt(i) + FL c/ FL (resol*nbpts)));
		}
	}
	glVertex3f(0.5,ValPt(nbpts),0.0);
	glEnd();
	glColor3f(1.0,0.0,1.0);
	glBegin(GL_LINE_STRIP);
	for(int i=0; i < nbpts; i++)
	{
		for(int c=0; c < resol; c++)
		{
		glVertex3f(GetPt(i)+ FL c/ FL (resol*nbpts), CubicInterpolate(ValPt(i-1), ValPt(i), ValPt(i+1), ValPt(i+2), /* Valeur de x */ FL c/ FL resol ), 0.0);
		}
	}
	glVertex3f(0.5,ValPt(nbpts),0.0);
	glEnd();
	glColor3f(1.0,1.0,0.0);
	glPointSize(4);
	glBegin(GL_POINTS);
	for(int m=0; m <= nbpts; m++)
		glVertex3f(FL m/ FL nbpts - 0.5, ValPt(m), 0.0);
	glEnd();
}

#endif
