/***************************************************************************
 *   Copyright (C) 2006 by BJT (Bjarne Junior Team)   *
 *      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <cstdlib>

#include <GL/glut.h>
#include <GL/glu.h>
#include <GL/gl.h>
#include "memory.h"
#include "stdio.h"
#include "stdlib.h"
#include <pthread.h>
#include "unistd.h"
#include "time.h"
#include "math.h"

#define FL (float)
#define PI FL(3.1415926535897932384626)


using namespace std;

// float speed= 0.038;
int speed= 68;
int lastFrameTime = 0;

int runtime;
int idletime = 0;
int bufferingtime = 0;
int rendurate = 0;


int width, height;

float* MesBitmaps[40];
float* MesImages[10];
int dispo = 0;
bool buffering = true;
float *Limage;

#define TAILLE 200

int nbpts = 5;
int resol = 25;

bool loading = true;
float progbar = 0;

float speede = 0;
float dim = 0.5;

pthread_t initialisation;
pthread_t picbuf;

struct pt
{
	float x,y,z;
};

float points[5] = { 0.2, -0.4, 0.2, -0.2, 0.2 };

float points2[5][5];

void renderScene(void);

#include "dessin.h"

void print_stroke_string(void* font, char* s)
{
   if (s && strlen(s)) {
      while (*s) {
         glutStrokeCharacter(font, *s);
         s++;
      }
   }
}

void print_bitmap_string(void* font, char* s)
{
   if (s && strlen(s)) {
      while (*s) {
         glutBitmapCharacter(font, *s);
         s++;
      }
   }
}

void* stroke_fonts[2] = {
	GLUT_STROKE_ROMAN,
	GLUT_STROKE_MONO_ROMAN
};

bool    g_gamemode;                                     // GLUT GameMode ON/OFF
bool    g_fullscreen;                                   // Fullscreen Mode ON/OFF (When g_gamemode Is OFF)
bool	g_light = false;	                            // Lighting ON/OFF 
GLfloat	g_xrot = 0.0f;                                  // X Rotation 
GLfloat	g_yrot = 0.0f;                                  // Y Rotation 
GLfloat g_xspeed = 0.0f;	                            // X Rotation Speed 
GLfloat g_yspeed = 0.0f;	                            // Y Rotation Speed 
GLfloat	g_z = -5.0f;		                            // Depth Into The Screen 
GLfloat g_lightAmbient[]  =	{ 0.5f, 0.5f, 0.5f, 1.0f }; // Ambient Light 
GLfloat g_lightDiffuse[]  =	{ 1.0f, 1.0f, 1.0f, 1.0f }; // Fiffuse Light 
GLfloat g_lightPosition[] = { 0.0f, 0.0f, 2.0f, 1.0f }; // Light Source Position 
GLuint	g_filter = 0;                                   // Which Filter To Use 
GLuint	g_fogMode[]= { GL_EXP, GL_EXP2, GL_LINEAR };    // Storage For Three Types Of Fog (NEW)
GLuint	g_fogfilter = 0;                                // Which Fog Mode To Use (NEW)
GLfloat	g_fogColor[4] = {0.5f,0.5f,0.5f,1.0f};          // Fog Color (NEW)

void Chrono (int value)
{
	int tps = glutGet(GLUT_ELAPSED_TIME);
	renderScene();
	tps = glutGet(GLUT_ELAPSED_TIME) - tps;
// 	printf("temps de rendu: %dms\n", tps);
	tps = speed - tps +1;
	if(tps > 0)
	{
		idletime += tps;
		glutTimerFunc(tps ,Chrono,0);
	}
	else 
		Chrono(0);
}

void InitGL ( GLvoid )     // Create Some Everyday Functions
{
GLfloat LightAmbient[]=  { 0.5f, 0.5f, 0.5f, 1.0f };
GLfloat LightDiffuse[]=  { 1.0f, 1.0f, 1.0f, 1.0f };
GLfloat LightPosition[]= { 0.0f, 0.0f, 2.0f, 1.0f };
	glShadeModel(GL_SMOOTH);							// Enable Smooth Shading
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);				// Black Background
	glClearDepth(1.0f);									// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	glEnable ( GL_COLOR_MATERIAL );
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	glLightfv(GL_LIGHT1, GL_AMBIENT, LightAmbient); // Setup The Ambient Light
	glLightfv(GL_LIGHT1, GL_DIFFUSE, LightDiffuse); // Setup The Diffuse Light
	glLightfv(GL_LIGHT1, GL_POSITION,LightPosition); // Position The Light
	glEnable(GL_LIGHT1);
	glFogi(GL_FOG_MODE,GL_EXP);
	glHint(GL_FOG_HINT, GL_NICEST);
	float couleur[4]={0,0,0,1.f};
	glFogf(GL_FOG_DENSITY, 0.12f);	
	glFogfv(GL_FOG_COLOR, couleur);
	glFogf(GL_FOG_START, .5f);
	glFogf(GL_FOG_END, 50.f);
	glEnable(GL_FOG);

  glViewport(0, 0, width, height);              // Reset The Current Viewport And Perspective Transformation

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(0, width, 0, height);
  glMatrixMode(GL_MODELVIEW);
//   glutTimerFunc(0,Chrono,0);
}

void PointsInit()
{
	srand(time(NULL));
	for( int c=0; c < nbpts; c++)
		for(int d=0; d < nbpts; d++)
			points2[c][d] = rand() / FL (RAND_MAX/2) - 1.0;
}


Couleur col1, col2;
static int t= 0;
static int u = 0;
static int c = 0;
static int d = 0;
static int e = 0;
// static int m,n,o,p;
int f = 0;
float buff;
Couleur colo;

static pthread_mutex_t my_mutex;

float *Barre;

void ProgressBar(void)
{
// 	printf("ProgressBar\n");
	int max = 493*progbar;
	for(int i=5; i < 93; i++)
		for(int j=5; j < max; j++) // 495
	{
		Barre[(i*500+j)*3] = 0.99;
		Barre[(i*500+j)*3+1] = 0.94;
		Barre[(i*500+j)*3+2] = 0.03;
	}
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glColor3f(1.0,0.0,1.0);
	glRasterPos2f((width-500)/2, (height-100)/2);
	glDrawPixels(500,100,GL_RGB, GL_FLOAT, Barre);
	glutSwapBuffers();
}

void* MakePictures(void *param)
{
	int tptst = glutGet(GLUT_ELAPSED_TIME);
	colo.Rouge = col2.Rouge - col1.Rouge;
	colo.Vert = col2.Vert - col1.Vert;
	colo.Bleu = col2.Bleu - col1.Bleu;
	for(int i=0; i < height; i++)
	{
// 		sched_yield();
		for(int j=0; j < width; j++)
		{
			buff = CubicInterpolate(GetBit(MesBitmaps[0],j,i), GetBit(MesBitmaps[1],j,i), GetBit(MesBitmaps[2],j,i), GetBit(MesBitmaps[3],j,i), FL c/ 28.0);
			SetPix(MesImages[e], j, i, RED, 1.0 - buff*colo.Rouge);
			SetPix(MesImages[e], j, i, GREEN, 1.0 - buff*colo.Vert);
			SetPix(MesImages[e], j, i, BLUE, 1.0 - buff*colo.Bleu);
		}
	}
// 	static int towhat = width*height;
// 	int j = 0;
// 	for(int i=0; i < towhat; i++, j+=3)
// 	{
// 		buff = CubicInterpolate(MesBitmaps[0][i], MesBitmaps[1][i], MesBitmaps[2][i], MesBitmaps[3][i], FL c/ 28.0);
// 		MesImages[e][j] = 1.0 - buff*colo.Rouge;
// 		MesImages[e][j+1] = 1.0 - buff*colo.Vert;
// 		MesImages[e][j+2] = 1.0 - buff*colo.Bleu;
// 	}
	
	c++;
	if(c == 28)
	{
		c = 0;
		MesBitmaps[10] = MesBitmaps[0];
		MesBitmaps[0] = MesBitmaps[1];
		MesBitmaps[1] = MesBitmaps[2];
		MesBitmaps[2] = MesBitmaps[3];
		int nx = rand()%6+4;
		MesBitmaps[3] = MesBitmaps[nx];
		MesBitmaps[nx] = MesBitmaps[10];
	}
	(e==9)?e=0:e++;
	dispo++;
	tptst = glutGet(GLUT_ELAPSED_TIME) - tptst;
	bufferingtime += tptst;
// 	printf("buffering one picture: %dms -- dispo: %d\n", tptst, dispo);
	sched_yield();
	if(dispo < 10)
		MakePictures(NULL);
	else
		buffering = false;
}


void* Init_Nuages(void* param)
{
// 	usleep(4000);
	float* rands = RandInit(65536);
	SolidNoise(MesBitmaps[0], width, height, rands);
	free(rands);
// 	progbar += 0.25;
	rands = RandInit(65536);
	SolidNoise(MesBitmaps[1], width, height, rands);
// 	progbar += 0.25;
	free(rands);
	rands = RandInit(65536);
	SolidNoise(MesBitmaps[2], width, height, rands);
// 	progbar += 0.25;
	free(rands);
	rands = RandInit(65536);
	SolidNoise(MesBitmaps[3], width, height, rands);
// 	progbar += 0.25;
	free(rands);
	rands = RandInit(65536);
	SolidNoise(MesBitmaps[4], width, height, rands);
	free(rands);
	rands = RandInit(65536);
	SolidNoise(MesBitmaps[5], width, height, rands);
	free(rands);
	rands = RandInit(65536);
	SolidNoise(MesBitmaps[6], width, height, rands);
	free(rands);
	rands = RandInit(65536);
	SolidNoise(MesBitmaps[7], width, height, rands);
	free(rands);
	rands = RandInit(65536);
	SolidNoise(MesBitmaps[8], width, height, rands);
	free(rands);
	rands = RandInit(65536);
	SolidNoise(MesBitmaps[9], width, height, rands);
	free(rands);
	runtime = glutGet(GLUT_ELAPSED_TIME);
	idletime = 0;
	loading = 0;
	if (pthread_create(&picbuf, NULL, MakePictures, NULL)) { 
		printf("pthread_create error\n"); 
		exit(EXIT_FAILURE); 
	} 
}


void* Draw_Nuages()
{
	if(lastFrameTime == 0)
	{
		lastFrameTime = glutGet(GLUT_ELAPSED_TIME);
	}
	int now = glutGet(GLUT_ELAPSED_TIME);
	int elapsedMilliseconds = now - lastFrameTime;
// 	printf("temps depuis le dernier rendu: %dms\n", elapsedMilliseconds);
	if(elapsedMilliseconds > speed)
	{
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
// 		if(t == 0)
// 			u= 3;
// 		else
// 			u = t-1;
// 		u = u%4;
// 		m = t%4;
// 		n = (t+1)%4;
// 		o = (t+2)%4;
		
		glRasterPos2f(0,0);
// 		ColorMap(Limage, MesBitmaps[4], width, height, col1, col2);
// 		printf("picture number %d\n", t%40);
// 		glDrawPixels(width,height,GL_RGB, GL_FLOAT, Limage);
		glDrawPixels(width,height,GL_RGB, GL_FLOAT, MesImages[d]);
		if(dispo < 5 && !buffering)
		{
			if (pthread_create(&picbuf, NULL, MakePictures, NULL)) { 
				printf("pthread_create error for making pictures\n"); 
				exit(EXIT_FAILURE); 
			}
			buffering = true;
		}
		if(dispo > 0)
		{
			(d==9)?d=0:d++;
			dispo--;
		}
		else
		{
			printf("trop court...\n");
			rendurate++;
		}
// 		Draw_Tableau();
		glutSwapBuffers();
		lastFrameTime = now;
	}
}

void renderScene(void)
{
	if(loading)
		ProgressBar();
	else
		Draw_Nuages();
	
}

int mode = 0;

void keyboard(unsigned char key, int x, int y)
{
	if(key == 27 || key == 'q')
	{
		runtime = glutGet(GLUT_ELAPSED_TIME) - runtime;
		printf("temps total d'excution: %dms\n", runtime);
		printf("temps total inutilis: %dms\n", idletime);
		printf("temps total de buffering: %dms\n", bufferingtime);
		printf("nombre de rendus rats: %d\n", rendurate);
		glutSetCursor(GLUT_CURSOR_RIGHT_ARROW); exit(1);
	}
	switch(key)
	{
		case 'r': float* rands = RandInit(65536); SolidNoise(Limage, width, height, rands); break;
		default: break;
	}
	printf("key stroked\n");
	
}



int main(int argc, char *argv[])
{
    	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA | GLUT_ALPHA);
	width = glutGet(GLUT_SCREEN_WIDTH);
	height = glutGet(GLUT_SCREEN_HEIGHT);
	glutInitWindowPosition(100,100);
	glutInitWindowSize(width,height);
	glutCreateWindow("xD InTeRpOlAtIoN...");
 	glutFullScreen();
	width = glutGet(GLUT_WINDOW_WIDTH);
	height = glutGet(GLUT_WINDOW_HEIGHT);
	glutDisplayFunc(renderScene);
	
	
	
	glutIdleFunc(NULL);
// 	glutIdleFunc(renderScene);
	glutKeyboardFunc( keyboard );
	glutSetCursor(GLUT_CURSOR_NONE);
	InitGL();
	glViewport(0, 0, width, height);
	PointsInit();
// 	Limage = PictureInit(width, height, 3);
	for(int i = 0; i<10; i++)
		MesImages[i] = PictureInit(width, height, 3);
	/*float* MyBitmap = BitmapInit(width, height);
	float* MyBitmap2 = BitmapInit(width, height);
	float* MyBitmap3 = BitmapInit(width, height);
	float* MyBitmap4 = BitmapInit(width, height);*/
	
// 	RandInit(512);
	col1.Rouge = 0.1;
	col1.Vert = 0.24;
	col1.Bleu = 0.52;
	
	
// 	col1.Rouge = 0.04;
// 	col1.Vert = 0.12;
// 	col1.Bleu = 0.28;
	col2.Rouge = 1.0;
	col2.Vert = 1.0;
	col2.Bleu = 1.0;

	
// 	ColorMap(Limage, MyBitmap, width, height, col1, col2);
	
	MesBitmaps[0] = BitmapInit(width, height);
// 	MesBitmaps[10] = MyBitmap2;
// 	MesBitmaps[20] = MyBitmap3;
// 	MesBitmaps[30] = MyBitmap4;
	MesBitmaps[1] = BitmapInit(width, height);
	MesBitmaps[2] = BitmapInit(width, height);
	MesBitmaps[3] = BitmapInit(width, height);
	MesBitmaps[4] = BitmapInit(width, height);
	MesBitmaps[5] = BitmapInit(width, height);
	MesBitmaps[6] = BitmapInit(width, height);
	MesBitmaps[7] = BitmapInit(width, height);
	MesBitmaps[8] = BitmapInit(width, height);
	MesBitmaps[9] = BitmapInit(width, height);
// 	MesBitmaps[10] = BitmapInit(width, height);
	/*for(int c=1; c< 10; c++)
	{
		MesBitmaps[c] = BitmapInit(width, height);
		for(int i=0; i < height; i++)
			for(int j=0; j < width; j++)
			{
				
// 				SetBit(MesBitmaps[c], j, i, LinearInterpolate(GetBit(MesBitmaps[0],j,i), GetBit(MesBitmaps[10],j,i), FL c/ 10.0));
				SetBit(MesBitmaps[c], j, i, CubicInterpolate(GetBit(MesBitmaps[30],j,i), GetBit(MesBitmaps[0],j,i), GetBit(MesBitmaps[10],j,i), GetBit(MesBitmaps[20],j,i), FL c/ 10.0));
			}
			printf("Intepolated %d out of %d\n", c, 10);
	}
	for(int c=11; c< 20; c++)
	{
		MesBitmaps[c] = BitmapInit(width, height);
		for(int i=0; i < height; i++)
			for(int j=0; j < width; j++)
		{
				
// 			SetBit(MesBitmaps[c], j, i, LinearInterpolate(GetBit(MesBitmaps[10],j,i), GetBit(MesBitmaps[20],j,i), FL (c-10)/ 10.0));
			SetBit(MesBitmaps[c], j, i, CubicInterpolate(GetBit(MesBitmaps[0],j,i), GetBit(MesBitmaps[10],j,i), GetBit(MesBitmaps[20],j,i), GetBit(MesBitmaps[30],j,i), FL (c-10)/ 10.0));
		}
		printf("Intepolated %d out of %d\n", c, 10);
	}
	for(int c=21; c< 30; c++)
	{
		MesBitmaps[c] = BitmapInit(width, height);
		for(int i=0; i < height; i++)
			for(int j=0; j < width; j++)
		{
				
// 			SetBit(MesBitmaps[c], j, i, LinearInterpolate(GetBit(MesBitmaps[20],j,i), GetBit(MesBitmaps[30],j,i), FL (c-20)/ 10.0));
			SetBit(MesBitmaps[c], j, i, CubicInterpolate(GetBit(MesBitmaps[10],j,i), GetBit(MesBitmaps[20],j,i), GetBit(MesBitmaps[30],j,i), GetBit(MesBitmaps[0],j,i), FL (c-20)/ 10.0));
		}
		printf("Intepolated %d out of %d\n", c, 10);
	}
	for(int c=31; c< 40; c++)
	{
		MesBitmaps[c] = BitmapInit(width, height);
		for(int i=0; i < height; i++)
			for(int j=0; j < width; j++)
		{
				
// 			SetBit(MesBitmaps[c], j, i, LinearInterpolate(GetBit(MesBitmaps[30],j,i), GetBit(MesBitmaps[0],j,i), FL (c-30)/ 10.0));
			SetBit(MesBitmaps[c], j, i, CubicInterpolate(GetBit(MesBitmaps[20],j,i), GetBit(MesBitmaps[30],j,i), GetBit(MesBitmaps[0],j,i), GetBit(MesBitmaps[10],j,i), FL (c-30)/ 10.0));
		}
		printf("Intepolated %d out of %d\n", c, 10);
}*/
// 	SolidNoise(Limage, width, height, rands);
	Barre= PictureInit(500, 100, 3);
	for(int i=0; i < 100; i++)
		for(int j=0; j < 500; j++)
	{
		Barre[(i*500+j)*3] = 0.99;
		Barre[(i*500+j)*3+1] = 0.94;
		Barre[(i*500+j)*3+2] = 0.03;
	}
	for(int i=2; i < 97; i++)
		for(int j=2; j < 497; j++)
	{
		Barre[(i*500+j)*3] = 0.05;
		Barre[(i*500+j)*3+1] = 0.05;
		Barre[(i*500+j)*3+2] = 0.5;
	}
	
	glutTimerFunc(0,Chrono,0);
	if (pthread_create(&initialisation, NULL, Init_Nuages, NULL)) { 
		printf("pthread_create error\n"); 
		exit(EXIT_FAILURE); 
	} 
	glutMainLoop();
	return EXIT_SUCCESS;
}
